searchData={"items":[{"type":"behaviour","title":"QuickFactory","doc":"","ref":"QuickFactory.html"},{"type":"function","title":"QuickFactory.build/3","doc":"Builds a schema given the factory `module` and an optional\nlist/map of `params`.","ref":"QuickFactory.html#build/3"},{"type":"function","title":"QuickFactory.build_invalid_params/1","doc":"","ref":"QuickFactory.html#build_invalid_params/1"},{"type":"function","title":"QuickFactory.build_many_params/4","doc":"Builds many parameters for a schema `changeset/2` function given the factory\n`module` and an optional list/map of `params`.","ref":"QuickFactory.html#build_many_params/4"},{"type":"type","title":"QuickFactory.build_opts/0","doc":"","ref":"QuickFactory.html#t:build_opts/0"},{"type":"function","title":"QuickFactory.build_params/3","doc":"Builds the parameters for a schema `changeset/2` function given the factory\n`module` and an optional list/map of `params`.","ref":"QuickFactory.html#build_params/3"},{"type":"callback","title":"QuickFactory.build_struct/1","doc":"Callback that returns a struct with valid defaults for the schema.","ref":"QuickFactory.html#c:build_struct/1"},{"type":"callback","title":"QuickFactory.call/1","doc":"Callback that returns a map with valid defaults for the schema. <=== THE MAIN CALLBACK","ref":"QuickFactory.html#c:call/1"},{"type":"callback","title":"QuickFactory.changeset/0","doc":"Callback that returns which changeset function to use.","ref":"QuickFactory.html#c:changeset/0"},{"type":"function","title":"QuickFactory.cleanup!/2","doc":"Removes all the instances of a schema from the database given its factory\n`module`.","ref":"QuickFactory.html#cleanup!/2"},{"type":"function","title":"QuickFactory.insert!/3","doc":"Inserts a schema given the factory `module` and an optional list/map of\n`params`. Fails on error.","ref":"QuickFactory.html#insert!/3"},{"type":"function","title":"QuickFactory.insert_many!/4","doc":"Insert as many as `count` schemas given the factory `module` and an optional\nlist/map of `params`.","ref":"QuickFactory.html#insert_many!/4"},{"type":"callback","title":"QuickFactory.repo/0","doc":"Callback that returns the schema's repo module.","ref":"QuickFactory.html#c:repo/0"},{"type":"callback","title":"QuickFactory.schema/0","doc":"Callback that returns the schema module.","ref":"QuickFactory.html#c:schema/0"},{"type":"function","title":"QuickFactory.sequence/1","doc":"Shortcut for creating unique string values.\nAutomatically imported into a model factory when you `use QuickFactory`.\n\nThis is equivalent to `sequence(name, &\"#{name}#{&1}\")`. If you need to\ncustomize the returned string, see `sequence/2`.","ref":"QuickFactory.html#sequence/1"},{"type":"function","title":"Examples - QuickFactory.sequence/1","doc":"# Will generate \"username0\" then \"username1\", etc.\n    username: sequence(\"username\")\n\n    # Will generate \"Article Title0\" then \"Article Title1\", etc.\n    title: sequence(\"Article Title\")","ref":"QuickFactory.html#sequence/1-examples"},{"type":"function","title":"QuickFactory.sequence/2","doc":"Create sequences for generating unique values.\n\nThe `name` can be any term, although it is typically an atom describing the\nsequence. Each time a sequence is called with the same `name`, its number is\nincremented by one.","ref":"QuickFactory.html#sequence/2"},{"type":"function","title":"Examples - QuickFactory.sequence/2","doc":"# Will generate \"me-0@foo.com\" then \"me-1@foo.com\", etc.\n    sequence(:email, &\"me-#{&1}@foo.com\"),\n    # Will generate \"admin\" then \"user\", \"other\", \"admin\" etc.\n    sequence(:role, [\"admin\", \"user\", \"other\"])","ref":"QuickFactory.html#sequence/2-examples"},{"type":"function","title":"QuickFactory.sequence/3","doc":"Similar to `sequence/2` but it allows for passing a `start_at` option\nto the sequence generation.","ref":"QuickFactory.html#sequence/3"},{"type":"function","title":"Examples - QuickFactory.sequence/3","doc":"# Will generate \"me-100@foo.com\" then \"me-101@foo.com\", etc.\n    email: sequence(:email, &\"me-#{&1}@foo.com\", start_at: 100),","ref":"QuickFactory.html#sequence/3-examples"},{"type":"function","title":"QuickFactory.sequence_reset/1","doc":"Reset sequence / sequences","ref":"QuickFactory.html#sequence_reset/1"},{"type":"module","title":"QuickFactory.Application","doc":"","ref":"QuickFactory.Application.html"},{"type":"module","title":"QuickFactory.Counters","doc":"This is a counter module that wraps :counters","ref":"QuickFactory.Counters.html"},{"type":"module","title":"Setup - QuickFactory.Counters","doc":"We can use this in our application by calling `QuickFactory.Counters.start()`\ninside our `test/test_helper.exs` file.","ref":"QuickFactory.Counters.html#module-setup"},{"type":"module","title":"Using Counters - QuickFactory.Counters","doc":"We can then use this module to add unique integers to each field, each value\nwill only be used once provided we continue to call `QuickFactory.Counters.next`\n\n```elixir\nQuickFactory.Counters.next(\"my_schema_field\")\n```","ref":"QuickFactory.Counters.html#module-using-counters"},{"type":"function","title":"QuickFactory.Counters.get/1","doc":"Gets the counter for a specific key","ref":"QuickFactory.Counters.html#get/1"},{"type":"function","title":"Example - QuickFactory.Counters.get/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.increment(key)\n    :ok\n    iex> QuickFactory.Counters.get(key)\n    1","ref":"QuickFactory.Counters.html#get/1-example"},{"type":"function","title":"QuickFactory.Counters.inc/1","doc":"","ref":"QuickFactory.Counters.html#inc/1"},{"type":"function","title":"QuickFactory.Counters.increment/1","doc":"Increments the counter for a specific key","ref":"QuickFactory.Counters.html#increment/1"},{"type":"function","title":"Example - QuickFactory.Counters.increment/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.increment(key)\n    :ok\n    iex> QuickFactory.Counters.get(key)\n    1","ref":"QuickFactory.Counters.html#increment/1-example"},{"type":"function","title":"QuickFactory.Counters.next/1","doc":"Increments and gets the current value for a specific key","ref":"QuickFactory.Counters.html#next/1"},{"type":"function","title":"Example - QuickFactory.Counters.next/1","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.next(key)\n    0\n    iex> QuickFactory.Counters.next(key)\n    1\n    iex> QuickFactory.Counters.next(key)\n    2","ref":"QuickFactory.Counters.html#next/1-example"},{"type":"function","title":"QuickFactory.Counters.put/2","doc":"Puts the counter for a specific key","ref":"QuickFactory.Counters.html#put/2"},{"type":"function","title":"Example - QuickFactory.Counters.put/2","doc":"iex> key = Enum.random(1..10_000_000)\n    iex> QuickFactory.Counters.increment(key)\n    :ok\n    iex> QuickFactory.Counters.put(key, 1234)\n    :ok\n    iex> QuickFactory.Counters.get(key)\n    1234","ref":"QuickFactory.Counters.html#put/2-example"},{"type":"function","title":"QuickFactory.Counters.reset/0","doc":"","ref":"QuickFactory.Counters.html#reset/0"},{"type":"function","title":"QuickFactory.Counters.start/0","doc":"This starts the Counters, you need to call this before calling any of the other\nfunctions in this module. Most commonly this will go in your `test/test_helper.exs` file","ref":"QuickFactory.Counters.html#start/0"},{"type":"module","title":"QuickFactory.Sequence","doc":"Module for generating sequential values.\n\nUse `QuickFactory.sequence/1` or `QuickFactory.sequence/2` to generate\nsequential values instead of calling this module directly.","ref":"QuickFactory.Sequence.html"},{"type":"function","title":"QuickFactory.Sequence.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"QuickFactory.Sequence.html#child_spec/1"},{"type":"function","title":"QuickFactory.Sequence.reset/0","doc":"Reset all sequences so that the next sequence starts from 0","ref":"QuickFactory.Sequence.html#reset/0"},{"type":"function","title":"Example - QuickFactory.Sequence.reset/0","doc":"QuickFactory.Sequence.next(\"joe\") # \"joe0\"\n    QuickFactory.Sequence.next(\"joe\") # \"joe1\"\n\n    QuickFactory.Sequence.reset()\n\n    QuickFactory.Sequence.next(\"joe\") # resets so the return value is \"joe0\"\n\nYou can use list as well\n\n    QuickFactory.Sequence.next(\"alphabet_sequence\", [\"A\", \"B\"]) # \"A\"\n    QuickFactory.Sequence.next(\"alphabet_sequence\", [\"A\", \"B\"]) # \"B\"\n\n    QuickFactory.Sequence.reset()\n\n    QuickFactory.Sequence.next(\"alphabet_sequence\", [\"A\", \"B\"]) # resets so the return value is \"A\"\n\nIf you want to reset sequences at the beginning of every test, put it in a\n`setup` block in your test.\n\n    setup do\n      QuickFactory.Sequence.reset()\n    end","ref":"QuickFactory.Sequence.html#reset/0-example"},{"type":"function","title":"QuickFactory.Sequence.reset/1","doc":"Reset specific sequences so long as they already exist. The sequences\nspecified will be reset to 0, while others will remain at their current index.\n\nYou can reset a single sequence,","ref":"QuickFactory.Sequence.html#reset/1"},{"type":"function","title":"Example - QuickFactory.Sequence.reset/1","doc":"QuickFactory.Sequence.next(:alphabet, [\"A\", \"B\", \"C\"]) # \"A\"\n    QuickFactory.Sequence.next(:alphabet, [\"A\", \"B\", \"C\"]) # \"B\"\n\n    QuickFactory.Sequence.reset(:alphabet)\n\n    QuickFactory.Sequence.next(:alphabet, [\"A\", \"B\", \"C\"]) # \"A\"\n\nAnd you can also reset multiple sequences at once,","ref":"QuickFactory.Sequence.html#reset/1-example"},{"type":"function","title":"Example - QuickFactory.Sequence.reset/1","doc":"QuickFactory.Sequence.next(:numeric, [1, 2, 3]) # 1\n    QuickFactory.Sequence.next(:numeric, [1, 2, 3]) # 2\n    QuickFactory.Sequence.next(\"joe\") # \"joe0\"\n    QuickFactory.Sequence.next(\"joe\") # \"joe1\"\n\n    QuickFactory.Sequence.reset([\"joe\", :numeric])\n\n    QuickFactory.Sequence.next(:numeric, [1, 2, 3]) # 1\n    QuickFactory.Sequence.next(\"joe\") # \"joe0\"","ref":"QuickFactory.Sequence.html#reset/1-example-1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}